# This file was auto-generated by Fern from our API Definition.

from backports.cached_property import cached_property

from .environment import PaveEnvironment
from .resources.cashflow.client import AsyncCashflowClient, CashflowClient


class Pave:
    def __init__(self, *, environment: PaveEnvironment = PaveEnvironment.PRODUCTION, api_key: str):
        self._environment = environment
        self.api_key = api_key

    @cached_property
    def cashflow(self) -> CashflowClient:
        return CashflowClient(environment=self._environment, api_key=self.api_key)


class AsyncPave:
    def __init__(self, *, environment: PaveEnvironment = PaveEnvironment.PRODUCTION, api_key: str):
        self._environment = environment
        self.api_key = api_key

    @cached_property
    def cashflow(self) -> AsyncCashflowClient:
        return AsyncCashflowClient(environment=self._environment, api_key=self.api_key)
